/*
 * Xelfi
 */

package xelfi.awt;

import java.awt.*;

/** This Layout is used in SpinEdit. It layouts SpinButton
 *  on the right side of SpinEdit and TextField on the left side.
 *
 * @version 2.1 1 Mar 1997
 * @author  Petr Hamernik
 */
public class SpinEditLayout implements LayoutManager {
    private int minWidth = 0, minHeight = 0;
    private int preferredWidth = 0, preferredHeight = 0;
    private boolean sizeUnknown = true;
	private TextField edit = null;
	private Component spin = null;
	
	/** Constructs new SpinEditLayout */
    public SpinEditLayout() {
		sizeUnknown = true;
    }

    public void addLayoutComponent(String name, Component comp) {
		if ((name.compareTo("E")) == 0)
			edit = (TextField) comp;
		if ((name.compareTo("S")) == 0)
			spin = comp;
    }

    public void removeLayoutComponent(Component comp) {
    }

    private void setSizes(Container parent) {
		if ((edit == null) || (spin == null))
			return;
        preferredWidth = edit.preferredSize(10).width + spin.preferredSize().width;
        preferredHeight = Math.max(edit.preferredSize(10).height, spin.preferredSize().height);
        minWidth = edit.minimumSize(10).width + spin.minimumSize().width;
        minHeight = Math.max(edit.minimumSize(10).height, spin.minimumSize().height);
    }


    public Dimension preferredLayoutSize(Container parent) {
		setSizes(parent);
        return new Dimension(preferredWidth, preferredHeight);
    }

    public Dimension minimumLayoutSize(Container parent) {
		setSizes(parent);
        return new Dimension(minWidth, minHeight);
    }

    public void layoutContainer(Container parent) {
		if ((edit == null) || (spin == null))
			return;
        setSizes(parent);
		Dimension d = parent.size();
		
		int w = spin.preferredSize().width;
		edit.reshape(0,0, d.width - w - 1,d.height - 1);
		spin.reshape(d.width - w, 0, w, d.height - 1);
    }
}
