package xelfi.awt;

import java.awt.*;

/**
 * Everyone who wants to be an element in xelfi owner draw lists
 * (XFListView, XFListViewPanel) should implement this interface.
 *
 * @version 1.00, 1 Feb 1996
 * @author Dafe
	Last change:  DF    3 Feb 97   11:00 am
*/
public interface XelfiListViewElement {

	/**
	 * Paints ifself at specified point (x-left y-center of element).
	 * Elements should paint themselfs to the rectangle given by
	 * their preferredSize method, otherwise they will corrupt
	 * final look.
	*/
	public void paint (Graphics g, int x, int y);

	/**
	 * Paints ifself with selection (x-left y-center of element).
	 * Elements should paint themselfs to the rectangle given by
	 * their preferredSize method, otherwise they will corrupt
	 * final look.
	*/
	public void paintSelected (Graphics g, int x, int y);

	/**
	 * Returns preferred size<br>
	*/
	public Dimension preferredSize ();
}
