/**
* Xelfi programming environment
*/

package xelfi.browser.document;

import xelfi.browser.view.*;
import xelfi.browser.util.Sort;
import java.util.*;
import java.io.*;
import java.awt.*;

/**
* This class
*
* @version 1.0
* @author Jan Jancura
*/
public class BrProject extends BrComponent
{
    protected boolean    parsed        = false;

   /**
    * This method
    *
    * @param
    * @return
    * @exception
    */
    public BrUser        owner;

   /**
    * This method
    *
    * @param
    * @return
    * @exception
    */
    public String        path;           // Project home

   /**
    * This method
    *
    * @param
    * @return
    * @exception
    */
    public Vector        prjPackagePath  = new Vector(10,3);

   /**
    * This method
    *
    * @param
    * @return
    * @exception
    */
    public Vector        sysPackagePath  = new Vector(10,3);
    private Vector       ptrPrjPackages  = new Vector(10,3);
    private Vector       ptrSysPackages  = new Vector(10,3);

   /**
    * This method
    *
    * @param
    * @return
    * @exception
    */
    public boolean       changed         = false;

    private boolean      opened          = false;


   /**
    * This method
    *
    * @param
    * @return
    * @exception
    */
    public BrProject(BrUser pOwner,String pName,String pPath)
    {
        path = pPath;
        name = pName;
        owner = pOwner;
    }

   /**
    * This method
    *
    * @param
    * @return
    * @exception
    */
    public boolean isOpened()
    {
        return (ComponentManager.getOpenedProject() == this);
    }

   /**
    * This method
    *
    * @param
    * @return
    * @exception
    */
    public void clearPaths()
    {
        prjPackagePath.removeAllElements();
        sysPackagePath.removeAllElements();
        ptrPrjPackages.removeAllElements();
        ptrSysPackages.removeAllElements();
        changed = true;
    }

   /**
    * This method
    *
    * @param
    * @return
    * @exception
    */
    public void addPath(String path,boolean prj)
    {// pouziva se pri nacitani projektu z disku,
    //  pri pridavani path v ProjectView
    //  a pri vytvareni Default project z ClassPath
        //if( path.equals(".") || path.equals("." + File.separator) )
        //    path = (new File(path)).getAbsolutePath();
        if( prj )
            prjPackagePath.addElement(path);
        else
            sysPackagePath.addElement(path);
        changed = true;
        return;
    }

   /**
    * This method
    *
    * @param
    * @return
    * @exception
    */
    public void parse()
       throws FileNotFoundException,IOException
    {

        //System.out.println("Project.parse ");
        int i,k=prjPackagePath.size();
        String s;
        Object v;
        for(i=0;i<k;i++)
        {
            s = (String)prjPackagePath.elementAt(i);
            v = ComponentManager.parseDir(s,1);
            if( v != null ) ptrPrjPackages.addElement(v);
        }
        k=sysPackagePath.size();
        for(i=0;i<k;i++)
        {
            s = (String)sysPackagePath.elementAt(i);
            v = ComponentManager.parseDir(s,2);
            if( v != null ) ptrSysPackages.addElement(v);
        }
        //System.out.println("Project.parse end");
        parsed = true;
        return;
    }

   /**
    * This method
    *
    * @param
    * @return
    * @exception
    */
    public void reparse()
       throws FileNotFoundException,IOException
    {

        //System.out.println("Project.reparse ");
        int i,k=prjPackagePath.size();
        String s;
        Object v;
        for(i=0;i<k;i++)
        {
            s = (String)prjPackagePath.elementAt(i);
            ComponentManager.removeDir(s);
        }
        ptrPrjPackages.removeAllElements();
        ptrSysPackages.removeAllElements();
        k=sysPackagePath.size();
        for(i=0;i<k;i++)
        {
            s = (String)sysPackagePath.elementAt(i);
            ComponentManager.removeDir(s);
        }
        k=prjPackagePath.size();
        for(i=0;i<k;i++)
        {
            s = (String)prjPackagePath.elementAt(i);
            v = ComponentManager.reparseDir(s,1);
            if( v != null ) ptrPrjPackages.addElement(v);
        }
        k=sysPackagePath.size();
        for(i=0;i<k;i++)
        {
            s = (String)sysPackagePath.elementAt(i);
            v = ComponentManager.reparseDir(s,2);
            if( v != null ) ptrSysPackages.addElement(v);
        }
        //System.out.println("Project.reparse end");
        parsed = true;
        return;
    }

   /**
    * This method
    *
    * @param
    * @return
    * @exception
    */
    public void markObjects()
    {
        //marks project classes and interfaces
    }

   /**
    * This method
    *
    * @param
    * @return
    * @exception
    */
    public void unmarkObjects()
    {
    }

   /**
    * This method
    *
    * @param
    * @return
    * @exception
    */
    private void Open()
    {
        opened = true;

        File f = new File(path);
        f = new File(f,name + ".prj");
        //System.out.println("Load file :" + f);
        DataInputStream is;
        try{
            is = new DataInputStream
                (new FileInputStream(f));

            int i,k;
            String str = " ";
            prjPackagePath.removeAllElements();

            k = (new Integer(is.readLine())).intValue();
            //System.out.println("k file :" +k+"  " + f);
            for(i=0;(i<k) && (str.length()!=0);i++)
            {
                str = is.readLine();
                addPath(str,true);
            }
            if( i != k )
            {
                System.out.println("Error in file :" + f);
                return;
            }
            k = (new Integer(is.readLine())).intValue();
            //System.out.println("k file :" +k+"  " + f);
            str = " ";
            for(i=0;(i<k) && (str.length()!=0);i++)
            {
                str = is.readLine();
                addPath(str,false);
                //System.out.println("str file :" + str);
            }
            if( i != k )
            {
                System.out.println("Error in file :" + f);
            }
        }catch(FileNotFoundException e)
        {
            //System.out.println("I cann't find file :" + f);
        }catch(IOException e)
        {
            System.out.println("Error in file :" + f);
        }
        changed = false;
        return;
    }
    void save()
    {
        //System.out.println("sSS USER");
        //save1();
        int i,j,l,k = ptrPrjPackages.size();
        Vector v;
        for(i=0;i<k;i++)
        {
            v = (Vector)ptrPrjPackages.elementAt(i);
            l = v.size();
            for(j=0;j<l;j++)
                ((BrPackage)v.elementAt(j)).save();
        }
        k = ptrSysPackages.size();
        for(i=0;i<k;i++)
        {
            v = (Vector)ptrSysPackages.elementAt(i);
            l = v.size();
            for(j=0;j<l;j++)
                ((BrPackage)v.elementAt(j)).save();
        }
        //System.out.println("Saved..");
    }
    private void save1()
    {
        if( !changed ) return;
        File f = new File(path);
        f = new File(f,name + ".prj");
        //System.out.println("Save file :" + f);
        DataOutputStream is;
        try{
            is = new DataOutputStream
                (new FileOutputStream(f));
        }catch(IOException e)
        {
            System.out.println("I cann't open file :" + f);
            return;
        }
        //System.out.println("Save file :" + f);
        int i,k = prjPackagePath.size();
        try{
            is.writeBytes((new Integer(k)).toString());
            is.writeBytes("\n");
            for(i=0;i<k;i++)
            {
                is.writeBytes((String)prjPackagePath.elementAt(i));
                is.writeBytes("\n");
            }
            k = sysPackagePath.size();
            is.writeBytes((new Integer(k)).toString());
            is.writeBytes("\n");
            //System.out.println("k file :" +k+"  "+ f);
            for(i=0;i<k;i++)
            {
                is.writeBytes((String)sysPackagePath.elementAt(i));
                is.writeBytes("\n");
            }
        }catch(IOException e)
        {
            System.out.println("Error in file :" + f);
            return;
        }
        System.out.println("OK ");
    }

    /**
     * This method returns a number of actually visible
     * subcomponents.
     * @param bs Actuall settings
     * @return Number of visible subcomponents
     */
    public int getComponentsNumber(BrSettings bs)
       throws FileNotFoundException,IOException
    {
        if( !opened ) Open();
        if( !parsed ) parse();

        int i,size = 0,k = ptrPrjPackages.size();
        if( bs.PackProject )
        {
            for(i=0;i<k;i++)
                size += ((Vector)ptrPrjPackages.elementAt(i)).size();
        }
        k = ptrSysPackages.size();
        if( bs.PackSystem )
        {
            for(i=0;i<k;i++)
                size += ((Vector)ptrSysPackages.elementAt(i)).size();
        }
        return size;
    }
    public int getComponents(BrSettings bs,BrComponent[] c,int from)
       throws FileNotFoundException,IOException
    {
        if( !opened ) Open();
        if( !parsed ) parse();

        int i,j,l,od,size = 0,k = ptrPrjPackages.size();
        Vector v;
        if( bs.PackProject )
        {
            for(i=0;i<k;i++)
            {
                v = (Vector)ptrPrjPackages.elementAt(i);
                l = v.size();
                od = from;
                for(j=0;j<l;j++)
                    c[from++] = (BrPackage)v.elementAt(j);
                c = (BrComponent[])Sort.sort(c,od,from);
            }
        }
        k = ptrSysPackages.size();
        if( bs.PackSystem )
        {
            for(i=0;i<k;i++)
            {
                v = (Vector)ptrSysPackages.elementAt(i);
                l = v.size();
                od = from;
                for(j=0;j<l;j++)
                    c[from++] = (BrPackage)v.elementAt(j);
                c = (BrComponent[])Sort.sort(c,od,from);
            }
        }
        return from;
    }
    public void openView(Frame f)
    {
        if( !opened ) Open();
        ProjectView v = new ProjectView(f,this);
    }
    public boolean selectable()
    {
        return true;
    }

}




