package xelfi.browser.util;
import java.awt.*;

/**
 * This modal dialog can have till three lines of text,
 * and some combination of buttons OK, Cancel, Yes or No.
 */
public class modalDialog extends xelfi.top.TopDialog
{
    Button      buttonOk;
    Button      buttonNo;
    Button      buttonCancel;
    Label       l1;
    Label       l2;
    Label       l3;
    Panel       pp;
    modalObject obj;
    int         index;

    /**
     * The OK and Cancel message box variable.
     */
    public final static int OK_CANCEL = 0;
    /**
     * The OK message box variable.
     */
    public final static int OK = 1;
    /**
     * The Yes, No and Cancel message box variable.
     */
    public final static int YES_NO_CANCEL = 3;
    /**
     * The Yes and No message box variable.
     */
    public final static int YES_NO = 2;

    /**
     * This constructor creates message box.
     * @param Frame f parent frame
     * @param modalObject o to this object the messages will be send
     * @param int ind identificator of this object
     * @param String s1 = first line of showed text (may be null)
     * @param String s2 = second line of showed text (may be null)
     * @param String s3 = third line of showed text (may be null)
     * @param int type determine which buttons will appeared
     */
    public modalDialog(Frame f,modalObject o,int ind,String s1,String s2,
                String s3,int type)
    {
        super(f,"Message box",true);
        addNotify();
        setLayout(new HorizLayout(HorizLayout.CENTER,
            HorizLayout.CENTER,0,0));

        obj = o;
        index = ind;

        switch( type )
        {
        case 0:
            l1 = new Label(s1);
            add(l1);
            if( s2 != null )
            {
                l2 = new Label(s2);
                add(l2);
                if( s3 != null)
                {
                    l3 = new Label(s3);
                    add(l3);
                }
            }
            pp = new Panel();
            pp.setLayout(new VertLayout());
            add(pp);
            buttonOk = new Button("Ok");
            pp.add(buttonOk);
            buttonCancel = new Button("Cancel");
            pp.add(buttonCancel);
            break;
        case 1:
            l1 = new Label(s1);
            add(l1);
            if( s2 != null )
            {
                l2 = new Label(s2);
                add(l2);
                if( s3 != null)
                {
                    l3 = new Label(s3);
                    add(l3);
                }
            }
            buttonOk = new Button("Ok");
            add(buttonOk);
            break;
        case 2:
            l1 = new Label(s1);
            add(l1);
            if( s2 != null )
            {
                l2 = new Label(s2);
                add(l2);
                if( s3 != null)
                {
                    l3 = new Label(s3);
                    add(l3);
                }
            }
            pp = new Panel();
            pp.setLayout(new VertLayout());
            add(pp);
            buttonOk = new Button("Yes");
            pp.add(buttonOk);
            buttonNo = new Button("No");
            pp.add(buttonNo);
            break;
        case 3:
            l1 = new Label(s1);
            add(l1);
            if( s2 != null )
            {
                l2 = new Label(s2);
                add(l2);
                if( s3 != null)
                {
                    l3 = new Label(s3);
                    add(l3);
                }
            }
            pp = new Panel();
            pp.setLayout(new VertLayout());
            add(pp);
            buttonOk = new Button("Yes");
            pp.add(buttonOk);
            buttonNo = new Button("No");
            pp.add(buttonNo);
            buttonCancel = new Button("Cancel");
            pp.add(buttonCancel);
            break;
        }
        /*System.out.println("bef p pref :" + preferredSize().width + "," + preferredSize().height);
        System.out.println("bef p ins :l " + insets().left + ",r " + insets().right);
        System.out.println("bef p ins :t " + insets().top + ",b " + insets().bottom);*/
    	pack();
        Dimension d = getToolkit().getScreenSize();
        move( (d.width - size().width) / 2 , (d.height - size().height) / 2 );
        /*System.out.println("past p pref :" + preferredSize().width + "," + preferredSize().height);
        System.out.println("past p ins :l " + insets().left + ",r " + insets().right);
        System.out.println("past p ins :t " + insets().top + ",b " + insets().bottom);*/

        show();
        resize(preferredSize());
        /*resize(insets().left + insets().right +
               preferredSize().width + 10, insets().top +
               insets().bottom + preferredSize().height + 10);*/

    }

    /**
     * Handle event method.
     * @param Event event
     * @return boolean
     * @see
     */
    public boolean handleEvent(Event event)
    {
        if( event.id == Event.ACTION_EVENT &&
            event.target == buttonOk )
        {
            clickedButtonOk();
            return true;
        }
        if( event.id == Event.ACTION_EVENT &&
            event.target == buttonNo )
        {
            clickedButtonNo();
            return true;
        }
        if( event.id == Event.ACTION_EVENT &&
            event.target == buttonCancel )
        {
            clickedButtonCancel();
            return true;
        }
        return super.handleEvent(event);
    }
    void clickedButtonOk()
    {
        hide();
        if( obj != null ) obj.onOk(index);
    }
    void clickedButtonNo()
    {
        hide();
        if( obj != null ) obj.onNo(index);
    }
    void clickedButtonCancel()
    {
        hide();
        if( obj != null ) obj.onCancel(index);
    }


}

