
package xelfi.browser.view;

import java.awt.*;
import java.io.*;
import java.util.*;

import xelfi.browser.document.*;
import xelfi.awt.PageControl;
import xelfi.util.EnhProperties;


public class BrowserSettings extends xelfi.top.TopDialog
{
    // Data
    static BrSettings       settings        = new BrSettings();
    static EnhProperties    properties      = null;
    static BrComponent      lastSelected    = null;

    static String[]         SMode           = staticInit();
    Button                  bOk,bCancel;
    static Vector           winRegister     = new Vector(10,10);

    static Frame            mainWindow;
    static Dimension        screenSize;

    static BrComponent[]    Clipboard;
    BrowserSettingsPanel    settingsPanel;

    static String[] staticInit()
    {
        String[] SMode = new String[5];
        SMode[0] = new String("Users:");
        SMode[1] = new String("Projects:");
        SMode[2] = new String("Packages:");
        SMode[3] = new String("Objects:");
        SMode[4] = new String("Members:");
        return SMode;
    }
    public static void Init(Frame f)
    {
        //System.out.println("BrowserSettings Init");

        // zaregistujeme nase options..
        xelfi.top.TopLevel.addOption(new BrowserOptions());

        // Init Document of Browser
        //   LOGIN USER
        ComponentManager.Init(System.getProperty("user.home")).
        LogIn(f).

        //   OPEN PROJECT
        openProject();

        //System.out.println("Logged user: " +
        //    ComponentManager.getLoggedUser());

        //System.out.println("Opened project: " +
        //    ComponentManager.getOpenedProject());

        // Init View of Browser

        mainWindow = f;
        screenSize = f.getToolkit().
            getScreenSize();

        //System.out.println("BrowserSettings Init end");

    }
    public static void Destroy()
    {
        //System.out.println("Browser shut down");
        ComponentManager.destroy();
        return;
    }
    public static void showClipboard()
    {
        if( Clipboard.length == 1 )
        {
            Clipboard[0].openView(mainWindow);
        }
    }
    public static BrComponent[] getSelectedComponents(int comp)
    {
        Vector v = new Vector(10,20);
        switch( comp )
        {
        case 0:if( lastSelected instanceof BrUser )
                   v.addElement(lastSelected);
               break;
        case 1:if( lastSelected instanceof BrProject )
                   v.addElement(lastSelected);
               break;
        case 2:if( lastSelected instanceof BrPackage )
                   v.addElement(lastSelected);
               break;
        case 3:if( lastSelected instanceof BrObject )
                   v.addElement(lastSelected);
               break;
        case 4:if( lastSelected instanceof BrMember )
                   v.addElement(lastSelected);
               break;
        }
        BrComponent[] components = null;
        int j,l,i,k = winRegister.size();
        for(i=0;i<k;i++)
        {
            components = getBPanel(i).getSelectedComponents(comp);
            l = components.length;
            for(j=0;j<l;j++)
                if( !v.contains(components[j]) )
                    v.addElement(components[j]);
        }

        k = v.size();
        switch( comp )
        {
        case 0:components = new BrUser[k];
               for(i=0;i<k;i++)
                   components[i] = (BrUser)(v.elementAt(i));
               break;
        case 1:components = new BrProject[k];
               for(i=0;i<k;i++)
                   components[i] = (BrProject)(v.elementAt(i));
               break;
        case 2:components = new BrPackage[k];
               for(i=0;i<k;i++)
                   components[i] = (BrPackage)(v.elementAt(i));
               break;
        case 3:components = new BrObject[k];
               for(i=0;i<k;i++)
                   components[i] = (BrObject)(v.elementAt(i));
               break;
        case 4:components = new BrMember[k];
               for(i=0;i<k;i++)
                   components[i] = (BrMember)(v.elementAt(i));
               break;
        }
        return components;
    }
    public static void repaint(int num)
    {
        int i, k = winRegister.size();
        BrowserPanel p;
        BrSettings s;
        Window w;
        for(i=0;i<k;i++)
        {
            w = (Window)winRegister.elementAt(i);
            p = (BrowserPanel)w.getComponent(0);
            s = p.getSettings();
            if( num < (s.Mode + s.Columns) )
                p.refill(Math.max(num - s.Mode,0));
        }
        return;
    }
    public static int getBWNumber()
    {
        return winRegister.size();
    }
    public static String getBWTitle(int num)
    {
        Object o;
        o=winRegister.elementAt(num);
        if( o instanceof MyFrame )
            return ((Frame)o).getTitle();
        else
            return ((Dialog)o).getTitle();
    }
    public static Window getBW(int num)
    {
        return (Window)winRegister.elementAt(num);
    }
    public static BrowserPanel getBPanel(int num)
    {
        return (BrowserPanel)(((Window)(winRegister.elementAt(num))).
            getComponent(0));
    }

    /*static String           pomName;
    static BrComponent[]    pomAssoc1;
    static BrComponent      pomAssoc2;
    static int              newBegin,oldBegin;  */

    static public Window CreateBrowserWindow(int ID)
    {
        //System.out.println("BrowserSettings.CreateBrowserWindow ID");
        if( properties == null )
        {
            System.out.println("Error 1490");
            return CreateBrowserWindow(true);
        }
        BrSettings set = new BrSettings(properties,ID);

        Window w = set.Dialog? (Window) new MyDialog(mainWindow,
                                "Browser window ",false):
                             (Window) new MyFrame("Browser window ");
        BrowserPanel bp = new BrowserPanel(set);
        w.add("Center",bp);
        bp.initTitle();

        w.pack();
        if( set.Dialog ) ((Dialog)w).setResizable(true);

        //System.out.println("BrowserSettings.CreateBrowserWindow ID end");

        return w;
    }
    static public Window CreateBrowserWindow(boolean automatic)
    {
        //System.out.println("BrowserSettings.CreateBrowserWindow ()");
        Window w = settings.Dialog? (Window) new MyDialog(mainWindow,
                                "Browser window ",false):
                             (Window) new MyFrame("Browser window ");
        BrowserPanel bp = new BrowserPanel(settings);
        w.add("Center",bp);
        bp.initTitle();

        w.pack();
       if( settings.Dialog ) ((Dialog)w).setResizable(true);
        w.move(mainWindow.location().x,mainWindow.size().height +
            mainWindow.location().y);
        w.show();
        w.resize(w.insets().left + w.insets().right +
            w.preferredSize().width,Math.max( w.insets().top +
            w.insets().bottom + w.preferredSize().height,
            screenSize.height - mainWindow.size().height -
            mainWindow.location().y - 30));
        return w;
    }
    static public Window CreateBrowserWindow(BrSettings s,BrComponent[] comp)
    {
        //System.out.println("BrowserSettings.CreateBrowserWindow ()");
        Window w = settings.Dialog? (Window) new MyDialog(mainWindow,
                                "Browser window ",false):
                             (Window) new MyFrame("Browser window ");
        BrowserPanel bp = new BrowserPanel(s);
        bp.setRoot(comp);
        w.add("Center",bp);
        bp.initTitle();

        w.pack();
       if( settings.Dialog ) ((Dialog)w).setResizable(true);
        w.move(mainWindow.location().x,mainWindow.size().height +
            mainWindow.location().y);
        w.show();
        w.resize(w.insets().left + w.insets().right +
            w.preferredSize().width,Math.max( w.insets().top +
            w.insets().bottom + w.preferredSize().height,
            screenSize.height - mainWindow.size().height -
            mainWindow.location().y - 30));
        return w;
    }
    static void ChangePanel(Window w,BrSettings newSet)
    {
        //System.out.println("ChangePanel");
        int x = w.location().x,
            y = w.location().y,
            v = w.size().width,
            h = w.size().height;
        BrowserPanel bpOld = (BrowserPanel)w.getComponent(0);
        w.removeAll();
        if( w instanceof MyFrame  )
        {
            if( newSet.Dialog )
            {
                if( !winRegister.removeElement(w) )
                    System.out.println("ChangePanel: " +
                        "Odregistrovavam nezaregistrovane!!!");
                w.dispose();
                w = (Window) new MyDialog(mainWindow,
                    "Browser window ",false);
            }else
                ((Frame)w).setTitle("Browser window ");
        }else
        if( w instanceof MyDialog )
        {
            if( !newSet.Dialog )
            {
                if( !winRegister.removeElement(w) )
                    System.out.println("ChangePanel: "+
                        "Odregistrovavam nezaregistrovane!!!");
                w.dispose();
                w = (Window) new MyFrame("Browser window ");
            }else
                ((Dialog)w).setTitle("Browser window ");
        }
        //System.out.println("ChangePanel 2");
        BrowserPanel bp = new BrowserPanel(newSet,bpOld);
        //System.out.println("ChangePanel 3");
        w.add("Center",bp);
        //System.out.println("ChangePanel 4");
        bp.initTitle();
        //System.out.println("ChangePanel 5");

        // w.pack();
        if( newSet.Dialog ) ((Dialog)w).setResizable(true);
        /*w.move(mainWindow.location().x,mainWindow.size().height +
            mainWindow.location().y);
        w.show();
        w.resize(w.insets().left + w.insets().right +
            w.preferredSize().width,Math.max( w.insets().top +
            w.insets().bottom + w.preferredSize().height,
            screenSize.height - mainWindow.size().height -
            mainWindow.location().y - 30));*/
        w.move(x,y);
        w.resize(v,h);
        w.show();
        //System.out.println("ChangePanel end");
        return;
    }


    public BrowserSettings(Frame fr)
    {
        super(fr,"Browser settings window",true);
        init(0,null);
   }
    public BrowserSettings(int tab,BrWindow w)
    {
        super(mainWindow,"Browser settings window",true);
        init(tab,w);
    }
    private void init(int tab,BrWindow w)
    {
        addNotify();

        settingsPanel = new BrowserSettingsPanel(w);
        add("Center",settingsPanel);

        Panel p = new Panel();
        p.setLayout(new FlowLayout());
        bOk = new Button("Ok");
        p.add(bOk);

        bCancel = new Button("Cancel");
        p.add(bCancel);

        add("South",p);

        settingsPanel.setPage(tab);

        pack();
        move( (screenSize.width - size().width) / 2 ,
              (screenSize.height - size().height) / 2 );
        show();
        resize(preferredSize().width,preferredSize().height);
        setResizable(true);
        return;
    }
    public boolean handleEvent(Event event)
    {
       if (event.id == Event.WINDOW_DESTROY)
       {
           dispose();
           return true;
       }
       return super.handleEvent(event);
    }
   public boolean action(Event e, Object arg)
   {
       if (e.target == bOk)
       {
            settingsPanel.onOk();
           dispose();
           return true;
       }else
       if (e.target == bCancel)
       {
           dispose();
           return true;
       }
       return false;
   }
}

class MyFrame extends xelfi.top.TopFrame implements BrWindow
{
    BrowserPanel myPanel;
    MyFrame(String title)
    {
        super(title);
        BrowserSettings.winRegister.addElement(this);
    }
    public boolean handleEvent(Event event)
    {

       if (event.id == Event.WINDOW_DESTROY)
       {
            if( !BrowserSettings.winRegister.removeElement(this) )
              System.out.println("MyFrame: Odregistrovavam nezaregistrovane!!!");
           dispose();
           return true;
       }
       return super.handleEvent(event);
    }
    public int getID()
    {
        int i,k = BrowserSettings.winRegister.size();
        for(i=0;i<k;i++)
            if( BrowserSettings.winRegister.elementAt(i) == this )
                break;
        if( i == k )
            System.out.println("safsfg");
        return i;
    }
}
class MyDialog extends xelfi.top.TopDialog implements BrWindow
{
    BrowserPanel myPanel;
    MyDialog(Frame f,String title,boolean b)
    {
        super(f,title,b);
        BrowserSettings.winRegister.addElement(this);
    }
    public boolean handleEvent(Event event)
    {

       if (event.id == Event.WINDOW_DESTROY)
       {
            if( !BrowserSettings.winRegister.removeElement(this) )
              System.out.println("MyDialog: Odregistrovavam nezaregistrovane!!!");
           dispose();
           return true;
       }
       return super.handleEvent(event);
    }
    public int getID()
    {
        int i,k = BrowserSettings.winRegister.size();
        for(i=0;i<k;i++)
            if( BrowserSettings.winRegister.elementAt(i) == this )
                break;
        if( i == k )
            System.out.println("safsfg");
        return i;
    }
}












