/*
 * SKELETON GENERATED BY XELFI VISUAL IDE
 */

package xelfi.design.components.dialogs;

import java.awt.*;
import java.util.Vector;
import xelfi.design.components.*;

public class XFOrderDialog extends Dialog {
  public XFOrderDialog(Frame parent, XelfiVisualContainer aCont) {
    super(parent, true);
		
    setLayout(new BorderLayout());
    setBackground(Color.lightGray);
    setTitle("Setting order in:");
    componentsList = new List();
    add("Center", componentsList);
    panel1 = new Panel();
    panel1.setLayout(new FlowLayout());
    add("South", panel1);
    buttonUp = new Button("Up");
    buttonUp.disable();
    panel1.add(buttonUp);
    buttonDown = new Button("Down");
    buttonDown.disable();
    panel1.add(buttonDown);
    buttonOK = new Button("OK");
    panel1.add(buttonOK);
    buttonCancel = new Button("Cancel");
    panel1.add(buttonCancel);

    cont = aCont;
    Vector subs = cont.getSubComponents();
    resultArray = new int[subs.size()];
    for (int i=0; i<subs.size(); i++) {
      resultArray[i] = i;
      XelfiDesignComponent comp = (XelfiDesignComponent) subs.elementAt(i);
      componentsList.addItem(comp.getName() + " ["+comp.getClassName()+"]");
    }
    addNotify();
    reshape(0, 0, 300, 300);
  }

  public boolean handleEvent(Event evt) {
    if ((evt.target == this) && (evt.id == Event.WINDOW_DESTROY)) {
      hide();
      dispose();
    }
    else
    if (evt.id == Event.ACTION_EVENT && evt.target == buttonDown)
      return DirClicked(evt);
    else
    if (evt.id == Event.ACTION_EVENT && evt.target == buttonUp)
      return DirClicked(evt);
    else
    if (evt.id == Event.ACTION_EVENT && evt.target == buttonCancel)
      return CancelClicked(evt);
    else
    if (evt.id == Event.ACTION_EVENT && evt.target == buttonOK)
      return OKClicked(evt);
    else
    if (evt.id == Event.LIST_SELECT && evt.target == componentsList)
      return selChanged(evt);
    return super.handleEvent(evt);
  }

// Event handlers

  public boolean DirClicked(Event evt) {
    if (selected == -1) return false;
    if (evt.target == buttonUp && selected == 0) return false;
    if (evt.target == buttonDown && selected == (componentsList.countItems() -1)) return false;
    int temp = resultArray[selected];
    String selText = componentsList.getItem(selected);
    componentsList.delItem(selected);
    if (evt.target == buttonUp) {
      resultArray[selected] = resultArray[selected-1];
      resultArray[selected-1] = temp;
      selected --;
    }
    else {
      resultArray[selected] = resultArray[selected+1];
      resultArray[selected+1] = temp;
      selected ++;
    }
    componentsList.addItem(selText, selected);
    componentsList.select(selected);
    return true;
  }

  public boolean CancelClicked(Event evt) {
    hide();
    dispose();
    return true;
  }

  public boolean OKClicked(Event evt) {
    hide();

// according to resultArray set up components order in cont
    Vector subs = cont.getSubComponents();
    ((Container)cont).removeAll();
    XelfiDesignLayout xdl = cont.getDesignLayout();
    for (int i=0; i<resultArray.length; i++)
      xdl.layoutAdd((Container)cont, (XelfiVisualComponent)subs.elementAt(resultArray[i]));
    ((Container)cont).validate();		

    dispose();
    return true;
  }

  public boolean selChanged(Event evt) {
    if (selected == -1) {
      buttonUp.enable(); buttonDown.enable();
    }
    selected = ((Integer)evt.arg).intValue();
    return true;
  }

// End of event handlers

  List componentsList;
  Panel panel1;
  Button buttonUp;
  Button buttonDown;
  Button buttonOK;
  Button buttonCancel;

// Place for other methods/variables:
  XelfiVisualContainer cont;
  int selected = -1;
  int resultArray[];
}

// Place for other classes:

                           
