/**
* Xelfi
*/

package xelfi.design.components.property;

/**
 *
 * @version 	1.00, 28 Jan 1997
 * @author 	Petr Hamernik
 */

import java.io.*;
import java.awt.Frame;
import xelfi.design.components.XelfiDesignComponent;
import xelfi.design.components.dialogs.ImageNameSelectThread;
import xelfi.util.Debug;

public class XImageNamePropertyType {
	public static void invokeSpecialInput(Frame parent, XelfiDesignComponent aXdc, int aPropNum) {
		new ImageNameSelectThread("ImageNameSelectThread", parent, aXdc, aPropNum).start();
	}

	public static String viewString(Object property) {
		return "[Image]";
	}

	public static void saveToStream(Object property, DataOutput stream) throws 
		IOException {
		XFImageName iname = (XFImageName) property;
		stream.writeInt(iname.getType());
		stream.writeUTF(iname.getText1());
		if (iname.isPackage()) {
			stream.writeUTF(iname.getText2());
		}
	}

	public static XFImageName loadFromStream(DataInput stream) throws 
		IOException {
		int type = stream.readInt();

		String t1 = stream.readUTF();
		if (type == XFImageName.IN_PACKAGE) {
			String t2 = stream.readUTF();
			return new XFImageName(type, t1, t2);
		}
		else
			return new XFImageName(type, t1, "");
	}
}
