/**
* Xelfi
*/

package xelfi.design.forms;

import java.util.Vector;

/**
 * XelfiDesignInspectable interface is a common interface for objects that consist of
 * set of components, some of which can be selected.
 * @version 	1.00, 01 Nov 1996
 * @author 	Ian Formanek, Dave Simonek
 */

public interface XelfiDesignInspectable {

	//////////////////////////////////
	//	managing selected components //
	//////////////////////////////////

	/**
	 * Method to get list of all curently selected components.
	 * @return		vector of all curently selected components
	 * @see #setSelectedComponents
	 */
	public Vector getSelectedComponents();
	
	/**
	 * Method to set curently selected components.
	 * @param comps		vector of components that are selected
	 * @see #getSelectedComponents
	 */
	public void setSelectedComponents(Vector comps);
	
	/**
	 * Method to get list of all components on form.
	 * @return		vector of all components
	 */
	public Vector getAllComponents();

}