/**
* Xelfi programming environment
*/

package xelfi.editor;
import java.awt.Color;
/**
* This interface is used by StandardEditorCallback to ask about the
* background color of specified line.
*
* @version 1.0
* @author Jaroslav Tulach
*/

public interface BackgroundCallback {
  /** Returns the color that should be used to draw the
  * background of line that contains position p.
  * @param p the position
  * @return the color or null if you do not care about the line
  */
  public Color getBackground (Position p);

  /** This method can influence the foreground of line.
  * @return the color to use for foreground or null if syntax coloring should be used
  */
  public Color getForeground ();
};


