/**
* Xelfi programming environment
*/

package xelfi.editor;
/**
* Contains position, previous one and the next one.
*
* @version 1.0
* @author Jaroslav Tulach
*/

class PositionBox extends Object {
  /** this position */
  Position pos ;

  /** previous */
  PositionBox prev;

  /** next */
  PositionBox next;

  /** info */
  Object info;

  /** New pos cont box.
  * @param p the position
  * @param i the info for this position
  */
  PositionBox (Position p, Object i) {
    pos = p;
    info = i;
  };

  /** Inserts position p after this one.
  * @param p the position to insert
  * @param i the info
  */
  public PositionBox insertAfter (Position p, Object i) {
    PositionBox pb = new PositionBox (p, i);
    pb.prev = this;
    if ((pb.next = next) != null) {
      next.prev = pb;
    };
    next = pb;
    return pb;
  };

  /** Inserts position p before this one.
  * @param p the position to insert
  * @param i the info
  */
  public PositionBox insertBefore (Position p, Object i) {
    PositionBox pb = new PositionBox (p, i);
    pb.next = this;
    if ((pb.prev = prev) != null) {
      prev.next = pb;
    };
    prev = pb;
    return pb;
  };

  /** Removes this item from the list.
  */
  public void delete () {
    if (prev != null) prev.next = next;
    if (next != null) next.prev = prev;
  };
};








