/**
* The xelfi Editor
*/

package xelfi.editor;

/**
* One record for undo the delete action. Has method how to revert to previous state.
*
* @version 1.0
* @author Jaroslav Tulach
*/

class UndoDelete extends UndoEvent {
  /** the position action has taken place at */
  private Position at;

  /** column */
  private int column;
  
  /** the deleted text */
  private String text;

  /** New object.
  * @param a the position
  * @param t the text
  */
  public UndoDelete (Position a, String t) {
    at = a;
    column = at.getColumn ();
    text = t;
  }
  
  /** Undoes the event.
  * @return the position of undo
  */
  public Position undo () {
    try {
      at = at.column (column);
      at.insert (text);
      return at;
    } catch (NotAllowedException ex) {
      return null;
    }
  }
}


