/**
* Xelfi (PARTIALY GENERATED BY XELFI VISUAL IDE)
*/

package xelfi.top;

import java.awt.*;
import java.util.Hashtable;
import java.util.Enumeration;
import java.util.NoSuchElementException;
import java.io.IOException;
import xelfi.editor.Source;
import xelfi.editor.Editor;

/**
* @version 	1.01, 21 Mar 1997
* @author 		Ian Formanek
*/

public class SaveAskDialog extends Dialog {
  public SaveAskDialog(Frame parent) {
    super(parent, true);
    setLayout(new BorderLayout());
    setTitle("Modified Files:");
    filesList = new List();
    add("Center", filesList);
    buttonsPanel = new Panel();
    buttonsPanel.setLayout(new FlowLayout());
    add("South", buttonsPanel);
    buttonSave = new Button("Save");
    buttonsPanel.add(buttonSave);
    buttonSaveAll = new Button("Save All");
    buttonsPanel.add(buttonSaveAll);
    buttonDiscardAll = new Button("Discard All");
    buttonsPanel.add(buttonDiscardAll);
    buttonCancel = new Button("Cancel");
    buttonsPanel.add(buttonCancel);
    infoLabel = new Label("These modified files were not saved:");
    add("North", infoLabel);

    for (Enumeration e = Editor.loadedSources (); e.hasMoreElements();) {
      Source s = (Source)e.nextElement ();
      if (s.isModified()) {
        String name = s.getName ();
        filesList.addItem(name);
        files.put(name, s);
	 }
    }
    filesList.select(0);

    pack();
  }

  public Dimension preferredSize() {
    return new Dimension(320, 250);
  }

  public boolean handleEvent(Event evt) {
    if ((evt.target == this) && (evt.id == Event.WINDOW_DESTROY)) {
      hide(); dispose();
    }
    else
    if (evt.id == Event.ACTION_EVENT && evt.target == buttonDiscardAll)
      return doDiscardAll();
    else
    if (evt.id == Event.ACTION_EVENT && evt.target == buttonSaveAll)
      return doSaveAll();
    else
    if (evt.id == Event.ACTION_EVENT && evt.target == buttonSave)
      return saveSelected();
    else
    if (evt.id == Event.ACTION_EVENT && evt.target == buttonCancel) {
      hide(); dispose();
    }
    return super.handleEvent(evt);
  }

// Event handlers

  public boolean doDiscardAll() {
    hide(); 
    TopLevel.doExitXelfi();
    return true;
  }

  public boolean doSaveAll() {
    try {
      for (Enumeration e = files.elements(); e.hasMoreElements();)
        ((Source)(e.nextElement())).save();
    } catch (IOException e) {
    }
    System.gc ();
    System.runFinalization ();
    doDiscardAll();
    return true;
  }

  public boolean saveSelected() {
    Source s = (Source)files.get(filesList.getSelectedItem());
    if (s!= null) {
      try {
        s.save();
      } catch (IOException e) {
      }
      files.remove(filesList.getSelectedItem());
      filesList.delItem(filesList.getSelectedIndex());
    }
    if (filesList.countItems() == 0) {
      System.gc ();
      System.runFinalization ();
      doDiscardAll();  // there is nothing more left to save
    }
    return true;
  }

// End of event handlers

  List filesList;
  Panel buttonsPanel;
  Button buttonSave;
  Button buttonSaveAll;
  Button buttonDiscardAll;
  Button buttonCancel;
  Label infoLabel;

// Place for other methods/variables:

  Hashtable files = new Hashtable();

}

 
