/**  Special menu item in the Window menu. It is connected with JavaEditorFrame
* @author Filip Dvorak
* @version 1.0
*/

package xelfi.top.visual;

import java.awt.*;
import xelfi.xedit.JavaEditorFrame;
import xelfi.top.*;


public class EditorMenuItem extends CheckboxMenuItem
{
  protected JavaEditorFrame editor;
  protected static EditorMenuItem enabledOne = null;
  protected static boolean createSeparator = true;
  protected static EditorMenuItem selectedOne = null;

  public EditorMenuItem(JavaEditorFrame ed)
  {
    super(ed.getSource().getName());
    Menu winMenu = (Menu)TopLevel.getMenu().getItem(MainMenu.windowMenu);
    if(createSeparator)
    {
      winMenu.addSeparator();
      createSeparator = false;
    }
    winMenu.add(this);

    editor = ed;
  }

  public void selected()
  {
    TopLevel.bringToTop(editor, true);
    setState(true);
  }

    // je to jeste treba synchronizovat
  public void setState(boolean enable)
  {
    if(enable && enabledOne != this && enabledOne != null) enabledOne.setState(false);
    enabledOne = this;
    super.setState(enable);
  }

  public void removeSelf()
  {
    if(selectedOne == this) selectedOne = null;
    Menu winMenu = (Menu)TopLevel.getMenu().getItem(MainMenu.windowMenu);
    winMenu.remove(this);
  }
}




