/** Options Dialog
* @author: Filip Dvorak
* @version: 1.0
*/

package xelfi.top.visual;

import java.awt.*;
import java.util.*;
import xelfi.top.*;
import xelfi.awt.TabControl;

public class OptionsDialog extends TopDialog
{
  Button butOK;
  Button butCan;
  TabControl tabs;
  Vector panels;
  Vector xelOptions;
  CardLayout cardL;  // the layouts hides and showes panels inside multipanel
  Panel multip;

  public OptionsDialog(Vector optionsvec)
  {
    super(TopLevel.getMenu(), "Xelfi options", true);
    setResizable(true);

    xelOptions = optionsvec;
    int no = xelOptions.size(), i;
    panels = new Vector(no);

    multip = new Panel();
    cardL = new CardLayout(0, 0);
    multip.setLayout(cardL);
    tabs = new TabControl();
    // add panels into tab space
    for(i = 0; i < no; i++)
    {
      XelfiOptions xo = (XelfiOptions)xelOptions.elementAt(i);
      Panel p = xo.getPanel();
      String name = xo.getTabName();
      panels.addElement(p);
      if(p != null)
      {
        multip.add(name, p);
        tabs.addTab(name);
      }
    }
    // index in tab == index in panels == index in indextable

      // insert them into this dialog
    RowLayout rl = new RowLayout();
    setLayout(rl);
      // tab
    RowLayoutProperties dp = new RowLayoutProperties(new Insets(2, 2, 2, 6), 0.03f, 0.02f, 0.02f);
    add(tabs);
    rl.add(tabs, dp);
      // multipanel
    dp = new RowLayoutProperties(new Insets(0, 2, 0, 6), 0.8f);



//
//    Button b = new B("worhwfhewui");
//    add(b);
//    rl.add(b, dp);

    add(multip);
    rl.add(multip, dp);
      // button panel





    Panel bp = new Panel();
    dp = new RowLayoutProperties(new Insets(15, 2, 3, 2), 0.04f, 0.05f, 0.04f);
    add(bp);
    rl.add(bp, dp);

      // button panel setup
    ColLayout bpl = new ColLayout();
    bp.setLayout(bpl);
    ColLayoutProperties bpp = new ColLayoutProperties(new Insets(2, 2, 2, 2), 0.11f, 0.39f, 0.02f);
    butOK = new Button(" OK ");
    bp.add(butOK);
    bpl.add(butOK, bpp);
    bpp = new ColLayoutProperties(new Insets(2, 2, 2, 2), 0.08f, 0.01f, 0.39f);
    butCan = new Button("Cancel");
    bp.add(butCan);
    bpl.add(butCan, bpp);

    pack();
    pack();

    tabs.setVisible(0);
    cardL.first(multip);
  }


  public void show()
  {
    if(getPeer() == null) addNotify();
    Dimension scr = Toolkit.getDefaultToolkit().getScreenSize(), me = size();

    move((scr.width - me.width) / 2, (int)((scr.height - me.height) / 2.4));
    super.show();
  }

  public boolean handleEvent(Event evt)
  {
    switch(evt.id)
    {
      case Event.WINDOW_DESTROY:
        if(evt.target == this)
        {
          hide();
          dispose();
          return true;
        }
      case TabControl.TAB_CHANGE:
        cardL.show(multip, tabs.getTabName(tabs.getTabIndex()));
        return true;
    }
    return super.handleEvent(evt);
  }

  public boolean action(Event e, Object arg)
  {
    if(e.target == butOK)
    {
      saveData();
      hide();
      dispose();
      return true;
    }
    else if(e.target == butCan)
    {
      hide();
      dispose();
      return true;
    }
    return super.action(e, arg);
  }

  protected void saveData()
  {
    int size = xelOptions.size(), i;
    for(i = 0; i < size; i++)
      if(panels.elementAt(i) != null) ((XelfiOptions)xelOptions.elementAt(i)).onOK((Panel)(panels.elementAt(i)));
  }

  public Insets insets()   // Under JDK 1.0.2 for win95 insets doesnt work. This patch should help.
  {
    Insets i = super.insets();
    if(getPeer() != null && (i.top < 0 || i.bottom < 0 || i.left < 0 || i.right < 0))
      return new Insets(28, 4, 4, 4);
    else return i;
  }

}

